local player 
local ai_pos 
local ai_loop_pos
local function AiLoop(loop_funcs, loop_pos) 
local ret
 player = AiPlayer() + 1
while (true) do 
ret = loop_funcs[loop_pos[player]]()
if (ret) then 
break 
end 
loop_pos[player] = loop_pos[player] + 1
end
 return true
 end

function InitAiScripts_enemy7()
ai_pos = {1, 1, 1, 1, 1, 1, 1, 1}
ai_loop_pos = {1, 1, 1, 1, 1, 1, 1, 1} 
hotspotexists = nil 
end

local ai_loop_funcs = {
function() return AiForce(1,{"unit-buggy",7}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end,
function() return AiNeed("unit-harvester") end,
function() return AiForce(3,{"unit-assault",7}) end,
function() return AiWaitForce(3) end,
function() return AiAttackWithForce(3) end,
function() return AiForce(1,{"unit-heli",3}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end,
function() return AiNeed("unit-harvester") end,
function() return AiForce(3,{"unit-tank",6}) end,
function() return AiWaitForce(3) end,
function() return AiAttackWithForce(3) end,
function() return AiForce(1,{"unit-rtank",8}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end,
function() return AiForce(4,{"unit-jet",5}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end,
function() return AiNeed("unit-harvester") end,
function() return AiForce(4,{"unit-bazoo",6}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end,
function() return AiForce(1,{"unit-chopper",7}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end,
function() return AiForce(2,{"unit-chopper",3}) end,
function() return AiForce(2,{"unit-artil",3}) end,
function() return AiForce(2,{"unit-bomber",3}) end,
function() return AiForce(2,{"unit-bazoo",8}) end,
function() return AiWaitForce(2) end,
function() return AiAttackWithForce(2) end,
function() return AiForce(1,{"unit-grenadier",3}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end,
function() return AiForce(4,{"unit-rtank",7}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end,
function() 
ai_loop_pos[player] = 0; 
return false 
end,
}

local function HotSpotExists()
if (hotspotexists == nil) then
local hotspot = UnitTypeByIdent("unit-hotspot")
local count = Players[PlayerNumNeutral].UnitTypesCount[hotspot.Slot]
hotspotexists = (count ~= 0)
end 
return hotspotexists 
end

local function CheckPower()
local nuke = UnitTypeByIdent("unit-nukepowerplant")
local count = Players[AiPlayer()].UnitTypesCount[nuke.Slot]
if (count ~= 0) then 
return nil 
end 
return "unit-powerplant" 
end

local function GetBuildOrder() 
local order = {}
if (not HotSpotExists()) then 
order[1] = CheckPower()
 order[2] = nil
elseif (Players[AiPlayer()].MagmaStored < 300) then
order[1] = "unit-magmapump" 
order[2] = CheckPower() 
else
order[1] = CheckPower()
order[2] = "unit-magmapump" 
end 
return order 
 end

local ai_funcs = { 
function() AiDebug(false) return false end,
 -- Build magma pump or power plant first depending on resources
function() 
order = GetBuildOrder() 
if (order[1] ~= nil) then
return AiNeed(order[1]) 
else 
return false 
end 
end, 

function() 
order = GetBuildOrder() 
if (order[1] ~= nil) then
return AiWait(order[1]) 
else 
return false 
end 
end, 

function() 
order = GetBuildOrder() 
if (order[2] ~= nil) then
return AiNeed(order[2]) 
else 
return false 
end 
end, 

function() 
order = GetBuildOrder() 
if (order[2] ~= nil) then
return AiWait(order[2]) 
else 
return false 
end 
end,

function() return AiSet("unit-engineer", 6) end,
function() return AiNeed("unit-vault") end,
function() return AiNeed("unit-magmapump") end,
function() return AiWait("unit-vault") end,

function() return AiNeed("unit-magmapump") end,
function() return AiNeed("unit-vault") end,
function() return AiNeed("unit-magmapump") end,
function() return AiNeed("unit-aircraftfactory") end,
function() return AiForce(4,{"unit-jet",4}) end,
function() return AiNeed("unit-vfac") end,
function() return AiForce(4,{"unit-apcs",4}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiNeed("unit-vault") end,
function() return AiNeed("unit-magmapump") end,
function() return AiForce(4,{"unit-rtank",3}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiForce(0,{"unit-buggy",8}) end,
function() return AiWaitForce(0) end,
function() return AiAttackWithForce(0) end ,
function() return AiNeed("unit-magmapump") end,
function() return AiForce(5,{"unit-buggy",7}) end,
function() return AiWaitForce(5) end,
function() return AiAttackWithForce(5) end ,
function() return AiForce(0,{"unit-tank",7}) end,
function() return AiWaitForce(0) end,
function() return AiAttackWithForce(0) end ,
function() return AiForce(2,{"unit-chopper",4}) end,
function() return AiWaitForce(2) end,
function() return AiAttackWithForce(2) end ,
function() return AiNeed("unit-biggunturret") end,
function() return AiNeed("unit-vault") end,
function() return AiNeed("unit-camp") end,
function() return AiForce(4,{"unit-assault",7}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiForce(1,{"unit-bazoo",6}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end ,
function() return AiNeed("unit-cannon") end,
function() return AiForce(5,{"unit-rtank",4}) end,
function() return AiWaitForce(5) end,
function() return AiAttackWithForce(5) end ,
function() return AiForce(0,{"unit-tank",7}) end,
function() return AiWaitForce(0) end,
function() return AiAttackWithForce(0) end ,
function() return AiNeed("unit-camp") end,
function() return AiForce(4,{"unit-apcs",5}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiNeed("unit-aircraftfactory") end,
function() return AiForce(2,{"unit-grenadier",3}) end,
function() return AiWaitForce(2) end,
function() return AiAttackWithForce(2) end ,
function() return AiForce(5,{"unit-bazoo",4}) end,
function() return AiWaitForce(5) end,
function() return AiAttackWithForce(5) end ,
function() return AiForce(4,{"unit-rtank",3}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiNeed("unit-vfac") end,
function() return AiNeed("unit-cannon") end,
function() return AiForce(0,{"unit-assault",3}) end,
function() return AiWaitForce(0) end,
function() return AiAttackWithForce(0) end ,
function() return AiNeed("unit-powerplant") end,
function() return AiNeed("unit-harvester") end,
function() return AiNeed("unit-vfac") end,
function() return AiNeed("unit-gturret") end,
function() return AiNeed("unit-gturret") end,
function() return AiForce(1,{"unit-artil",3}) end,
function() return AiWaitForce(1) end,
function() return AiAttackWithForce(1) end ,
function() return AiForce(5,{"unit-bomber",8}) end,
function() return AiWaitForce(5) end,
function() return AiAttackWithForce(5) end ,
function() return AiForce(2,{"unit-grenadier",7}) end,
function() return AiWaitForce(2) end,
function() return AiAttackWithForce(2) end ,
function() return AiForce(4,{"unit-heli",5}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiNeed("unit-harvester") end,
function() return AiForce(3,{"unit-artil",3}) end,
function() return AiWaitForce(3) end,
function() return AiAttackWithForce(3) end ,
function() return AiNeed("unit-vault") end,
function() return AiNeed("unit-cannon") end,
function() return AiForce(5,{"unit-apcs",4}) end,
function() return AiWaitForce(5) end,
function() return AiAttackWithForce(5) end ,
function() return AiNeed("unit-nukepowerplant") end,
function() return AiNeed("unit-biggunturret") end,
function() return AiNeed("unit-cannon") end,
function() return AiNeed("unit-nukepowerplant") end,
function() return AiNeed("unit-vault") end,
function() return AiForce(0,{"unit-chopper",5}) end,
function() return AiForce(0,{"unit-chopper",3}) end,
function() return AiWaitForce(0) end,
function() return AiAttackWithForce(0) end ,
function() return AiNeed("unit-gturret") end,
function() return AiNeed("unit-harvester") end,
function() return AiForce(4,{"unit-bomber",3}) end,
function() return AiWaitForce(4) end,
function() return AiAttackWithForce(4) end ,
function() return AiForce(0,{"unit-assault",5}) end,
function() return AiWaitForce(0) end,
function() return AiAttackWithForce(0) end ,
function() return AiForce(3,{"unit-bazoo",4}) end,
function() return AiWaitForce(3) end,
function() return AiAttackWithForce(3) end ,
function() return AiNeed("unit-vault") end,
function() return AiNeed("unit-cannon") end,
function() return AiNeed("unit-vault") end,
function() return AiLoop(ai_loop_funcs, ai_loop_pos) end, 
}

function Aienemy7() 
return AiLoop(ai_funcs, ai_pos) 
end

RegisterAi("enemy7","enemy7",Aienemy7,InitAiScripts_enemy7)
