/*

 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package boswarsFontes;

import java.io.*;
import java.util.ArrayList;
import java.util.Scanner;

/**
 *
 * @author Rodrigo
 */
public class EA {

    /**
     * Attributes
     */
    private Population pop = null;
    private Enemy enemy = null;
    public int nenemies = 0;
    /**
     * Constructor
     */
    public EA() {
    }

    /**
     * Initialize EA
     */
    public void initialize() throws CloneNotSupportedException, FileNotFoundException, InterruptedException, IOException {
        /**
         * Instance population 'pop'
         */
        this.pop = new Population(1, 11, true);

        this.pop.createFVLogFile();
       
        this.evolution();

        MatchHandler.object().jumpLineBattleLogFile();

        /**
        * Update First Victory Log File
       */
        this.pop.updateFVLogFile();
    }

    /**
     * Perform evolution of 'pop'
     */
    public void evolution() throws CloneNotSupportedException, FileNotFoundException, InterruptedException, IOException {
        int counterMatch, re;
        ArrayList<String> enemyList = new ArrayList();
        File enemyFile;
        /**
         * Match Configurations
         */
        MatchHandler.object().setAuto(true);
        MatchHandler.object().setGUI(false);
        MatchHandler.object().setSpeed(1000);

        enemy = new Enemy(0);
        enemy.raffle();
        enemy.prepareForBattle();

        for (counterMatch = 0; counterMatch < 1; counterMatch++) {
            System.out.printf("Batalha %d\n", counterMatch + 1);
            this.pop.player.get(counterMatch).prepareForBattle();
            enemy.resetCounters();

            MatchHandler.object().callGame();
            this.pop.player.get(counterMatch).recoverStatistics();
            this.enemy.recoverStatistics();
            this.pop.player.get(counterMatch).evaluate(this.enemy);
            this.enemy.evaluate(this.pop.player.get(counterMatch));
            
            System.out.println("nKill " + this.pop.player.get(counterMatch).getnKill());
            System.out.println("nRaz " + this.pop.player.get(counterMatch).getnRaz());
            System.out.println("Score " + this.pop.player.get(counterMatch).getScore());
            System.out.println("Time " + this.pop.player.get(counterMatch).getCycle());
            System.out.println("enemy nKill " + this.enemy.getnKill());
            System.out.println("enemy nRaz " + this.enemy.getnRaz());
            System.out.println("enemy Score " + this.enemy.getScore());
            System.out.println("enemy Time " + this.enemy.getCycle());

            MatchHandler.object().updateBattleLogFile(this.pop.player.get(counterMatch), enemy);
        }

        /**
         * Order population
         */
        pop.sort();
        pop.setCurrPlayer(0);
        re = pop.player.get(pop.getCurrPlayer()).getReward();
        /*
         * Sets rewards and fitness
         */
        for(int i = 0; i < pop.player.size(); i++){
            pop.player.get(i).setReward(0);
            pop.player.get(i).setsFitness(0);
        }
        pop.player.get(pop.getCurrPlayer()).setReward(re);
            
        //if won, change enemy
        if (this.pop.player.get(pop.getCurrPlayer()).getReward() == 1) {
            if (enemy.raffle() == false) {
                /*Save new enemy script 
                this.pop.player.get(pop.getCurrPlayer()).setName("all_winner_enemy"+nenemies);
                this.pop.player.get(pop.getCurrPlayer()).decode();
                */
                //Save new enemy name on enemies database
                /*Scanner sc = new Scanner(new File("enemies.bwdb"));
                while (sc.hasNextLine()) {
                    enemyList.add(sc.nextLine());
                }
                sc.close();
                enemyList.add("enemy"+nenemies);
                enemyFile = new File("enemies.bwdb");
                PrintStream out = new PrintStream(new FileOutputStream(enemyFile, false));

                for (String line : enemyList) {
                    out.println(line);
                }
                out.close();
                */
                nenemies++;
                //break;
            }
        } else {
            enemy.won();
        }
        
        /**
        * Update population
        */
        this.pop.update(0);
        
        /**
         * Select an evolved individual from pop
         */
        this.pop.evolve(0);
    
    }
    public static PrintStream log_error = null;

    public static void main(String args[]) throws CloneNotSupportedException {
        try {
            log_error = new PrintStream(new File("log_error.txt"));
            EA e = new EA();
            e.initialize();
        } catch (Throwable ex) {
            ex.printStackTrace();
            ex.printStackTrace(EA.log_error);
        }
        log_error.close();
    }
}